<?php

namespace Drupal\mymodule;

use GuzzleHttp\ClientInterface;
use GuzzleHttp\Client;

class API {
  private $httpClient;

  public function __construct() {
    $this->httpClient = \Drupal::httpClient();
  }

  public function getResponse($uri) {
    $request = $this->httpClient->request('GET', $uri);
    $responseCode = $request->getStatusCode();

    $response = $request->getBody()->getContents();
    $response = json_decode($response, true);

    return $response;
  }

  public function getTypeNode($uri) {
    $type_node = explode('/', stristr($uri, 'api/'));

    return $type_node[1];
  }

  public function getSwapiId($uri) {
    $swapi_id = explode('/', stristr($uri, 'api/'));

    return $swapi_id[2];
  }

  public function checkBundle($bundle) {
    $bundles = \Drupal::getContainer()->get('entity_type.bundle.info')->getBundleInfo('node');
    foreach ($bundles as $key => $value) {
      if ($key == $bundle) {
        return true;
      }
    }
    return false;
  }

}
