<?php

namespace Drupal\mymodule\Plugin\QueueWorker;

use Drupal\Core\Queue\QueueWorkerBase;

/**
 * Comments
 *
 * @QueueWorker (
 *  id = "mymodule_node",
 *  title = "Queue create node",
 *  cron = {"time" = 60}
 * )
 */
class QueueWorkerNode extends QueueWorkerBase {

  /**
   * {@inheritdoc}
   */
  public function processItem($data) {
    $api = \Drupal::service('mymodule.custom_services');
    $queue_node_update = \Drupal::queue('mymodule_update');
    $bundle = $api->getTypeNode($data['url']);
    $swapi_id = (int)$api->getSwapiId($data['url']);
    $title = $data[array_keys($data)[0]];

    $node = \Drupal::entityTypeManager()
      ->getStorage('node')
      ->create([
        'type' => $bundle,
        'title' => $title,
        'field_swapi_id' => $swapi_id
      ]);
    $node->save();
    $queue_node_update->createItem($data);
  }
}
