<?php

namespace Drupal\mymodule\Plugin\QueueWorker;

use Drupal\Core\Queue\QueueWorkerBase;

/**
 * Comments
 *
 * @QueueWorker (
 *  id = "mymodule_api",
 *  title = "Queue api",
 *  cron = {"time" = 60}
 * )
 */
class QueueWorkerSwapi extends QueueWorkerBase {
  /**
   * {@inheritdoc}
   */

  // $data приходит в виде https://swapi.dev/api/string/
  public function processItem($data) {
    $api = \Drupal::service('mymodule.custom_services');
    $queue_node_update = \Drupal::queue('mymodule_update');
    $queue_node = \Drupal::queue('mymodule_node');

    $type_node = $api->getTypeNode($data);
    $result = $api->getResponse($data);
    $uri = $data;

    if (!empty($result['results'])) {
      do {
        $result = $api->getResponse($uri);
        foreach($result['results'] as $item) {
          $bundle = $api->getTypeNode($item['url']);
          $swapi_id = $api->getSwapiId($item['url']);

          if ($api->checkBundle($bundle)) {
            $node = \Drupal::entityTypeManager()
              ->getStorage('node')
              ->loadByProperties([
                'type' => $bundle,
                'field_swapi_id' => $swapi_id,
              ]);
            foreach ($node as $val) {
              $node_edited = $val;
            }
            if (!empty($node)) {
              if ($node_edited->field_edited->value !== $item['edited']) {
                $queue_node_update->createItem($item);
              }
            } else {
              $queue_node->createItem($item);
            }
          } else {
            \Drupal::logger('Queue mymodule_api')->notice("Content type $type_node не создан!");
          }
        }
        $uri = $result['next'];
      } while(!empty($uri));
    }
    \Drupal::logger('Queue mymodule_api')->notice("Очередь по $type_node была выполнена");
  }
}
